const path = require('path')
const UglifyJsPlugin = require('uglifyjs-webpack-plugin')

module.exports = {
    mode: 'production',
    entry: {
        'jis': './src/main.ts',
        'jis.min': './src/main.ts'
    },
    output: {
        path: path.resolve(__dirname, 'dist'),
        filename: '[name].js',
        libraryTarget: 'umd',
        library: {
            name: 'jis',
            type: 'global'
        },
        umdNamedDefine: true,
        globalObject: "this",
        libraryExport: "default"
    },
    resolve: {
        extensions: ['.ts', '.tsx', '.js']
    },
    // devtool: 'source-map',
    module: {
        rules: [{
            test: /\.tsx?$/,
            loader: 'ts-loader',
            exclude: /node_modules/
        }]
    },
    optimization: {
        minimizer: [
            new UglifyJsPlugin({
                include: /\.min\.js$/,
                uglifyOptions: {
                    output: {
                        comments: false
                    }
                }
            })
        ]
    }
}